#==BEGIN Define script parameters==
## Logging Behavior parameters
BUFFER_TTL="300"; # time between file writes
-SCRIPT_TTL="day"; # (day|hour)
+SCRIPT_TTL_TE="day"; # (day|hour)
#### TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option
DIR_TMP_DEFAULT="/dev/shm"; # Default parent of working directory
SCRIPT_TIME_START=$(date +%Y%m%dT%H%M%S.%N);
PATH="$HOME/.local/bin:$PATH"; # Add "$(systemd-path user-binaries)" path in case apps saved there
SCRIPT_HOSTNAME=$(hostname); # Save hostname of system running this script.
-SCRIPT_VERSION="0.3.9"; # Define version of script.
+SCRIPT_VERSION="0.4.4-alpha2"; # Define version of script.
SCRIPT_NAME="bkgpslog"; # Define basename of script file.
SCRIPT_URL="https://gitlab.com/baltakatei/ninfacyzga-01"; # Define wesite hosting this script.
AGE_VERSION="1.0.0-beta2"; # Define version of age (encryption program)
declare -Ag appRollCall # Associative array for storing app status
declare -Ag fileRollCall # Associative array for storing file status
declare -Ag dirRollCall # Associative array for storing dir status
-declare -a recPubKeys # for processArguments function
-declare recipients # for main function
+declare -a argRecPubKeys # for processArguments function
+# declare -a errorHistory # for correcting buffer lag
## Initialize variables
OPTION_VERBOSE=""; OPTION_ENCRYPT=""; OPTION_COMPRESS=""; OPTION_TMPDIR="";
+errReset=0; BUFFER_TTL_ADJ_FLOAT="";
#===BEGIN Declare local script functions===
checkapp() {
echoerr "OPTIONS:"
echoerr " -h, --help"
echoerr " Display help information."
- echoerr
echoerr " --version"
echoerr " Display script version."
- echoerr
echoerr " -v, --verbose"
echoerr " Display debugging info."
- echoerr
echoerr " -e, --encrypt"
echoerr " Encrypt output."
- echoerr
- echoerr " -r, --recipient [ pubkey string ]"
+ echoerr " -r, --recipient [ string pubkey ]"
echoerr " Specify recipient. May be age or ssh pubkey."
+ echoerr " May be specified multiple times for multiple pubkeys."
echoerr " See https://github.com/FiloSottile/age"
- echoerr
- echoerr " -o, --output [ directory ]"
+ echoerr " -o, --output [ path dir ]"
echoerr " Specify output directory to save logs."
- echoerr
echoerr " -c, --compress"
echoerr " Compress output with gzip (before encryption if enabled)."
- echoerr
echoerr " -z, --time-zone"
echoerr " Specify time zone. (ex: \"America/New_York\")"
- echoerr
- echoerr " -t, --temp-dir"
+ echoerr " -t, --temp-dir [path dir]"
echoerr " Specify parent directory for temporary working directory."
echoerr " Default: \"/dev/shm\""
+ echoerr " -R, --recipient-dir [path dir]"
+ echoerr " Specify directory containing files whose first lines are"
+ echoerr " to be interpreted as pubkey strings (see \\'-r\\' option)."
+ echoerr " -b, --buffer-ttl [integer]"
+ echoerr " Specify custom buffer period in seconds (default: 300 seconds)"
+ echoerr " -B, --script-ttl [integer]"
+ echoerr " Specify custom script time-to-live in seconds (default: \"day\")"
echoerr
echoerr "EXAMPLE: (bash script lines)"
- echoerr "/bin/bash bkgpslog -e -c \\"
+ echoerr "/bin/bash bkgpslog -v -e -c \\"
+ echoerr "-z \"UTC\" -t \"/dev/shm\" \\"
echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
echoerr "-o ~/Sync/Location"
--version) showVersion; exit 1;; # Show version
-v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
-o | --output) if [ -d "$2" ]; then DIR_OUT="$2"; vbm "DEBUG:DIR_OUT:$DIR_OUT"; shift; fi ;; # Define output directory.
- -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";;
- -r | --recipient) # Add 'age' recipient via public key string
- recPubKeys+=("$2"); vbm "STATUS:pubkey added:""$2"; shift;;
- -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";;
- -z | --time-zone) try setTimeZoneEV "$2"; shift;;
- -t | --temp-dir) OPTION_TMPDIR="true" && TMP_DIR_PRIORITY="$2"; shift;;
+ -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";; # Enable encryption
+ -r | --recipient) OPTION_RECIPIENTS="true"; argRecPubKeys+=("$2"); vbm "STATUS:pubkey added:""$2"; shift;; # Add recipients
+ -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";; # Enable compression
+ -z | --time-zone) try setTimeZoneEV "$2"; shift;; # Set timestamp timezone
+ -t | --temp-dir) OPTION_TMPDIR="true" && argTempDirPriority="$2"; shift;; # Set time zone
+ -R | --recipient-dir) OPTION_RECIPIENTS="true"; OPTION_RECDIR="true" && argRecDir="$2"; shift;; # Add recipient watch dir
+ -b | --buffer-ttl) OPTION_CUSTOM_BUFFERTTL="true" && argCustomBufferTTL="$2"; shift;; # Set custom buffer period (default: 300 seconds)
+ -B | --script-ttl) OPTION_CUSTOM_SCRIPTTTL_TE="true" && argCustomScriptTTL="$2"; shift;; # Set custom script TTL (default: "day")
*) echoerr "ERROR: Unrecognized argument: $1"; echoerr "STATUS:All arguments:$*"; exit 1;; # Handle unrecognized options.
esac
shift
#==END Display errors==
} # Display missing apps, files, dirs
-setScriptTTL() {
- #Desc: Sets script TTL
- #Usage: setScriptTTL arg1
- #Input: arg1: "day" or "hour"
- #Output: scriptTTL
- #Depends: timeUntilNextHour or timeUntilNextDay
- local ARG1
- ARG1="$1"
- if [[ "$ARG1" = "day" ]]; then
+magicSetScriptTTL() {
+ #Desc: Sets script_TTL seconds from provided time_element string argument
+ #Usage: magicSetScriptTTL [str time_element]
+ #Input: arg1: string (Ex: SCRIPT_TTL_TE; "day" or "hour")
+ #Output: var: SCRIPT_TTL (integer seconds)
+ #Depends: timeUntilNextHour, timeUntilNextDay
+ local argTimeElement
+ argTimeElement="$1"
+ if [[ "$argTimeElement" = "day" ]]; then
# Set script lifespan to end at start of next day
- if ! scriptTTL="$(timeUntilNextDay)"; then
- if [[ "$scriptTTL" -eq 0 ]]; then
- ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ if ! SCRIPT_TTL="$(timeUntilNextDay)"; then
+ if [[ "$SCRIPT_TTL" -eq 0 ]]; then
+ ((SCRIPT_TTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
else
yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
fi;
fi;
- elif [[ "$ARG1" = "hour" ]]; then
+ elif [[ "$argTimeElement" = "hour" ]]; then
# Set script lifespan to end at start of next hour
- if ! scriptTTL="$(timeUntilNextHour)"; then
- if [[ "$scriptTTL" -eq 0 ]]; then
- ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+ if ! SCRIPT_TTL="$(timeUntilNextHour)"; then
+ if [[ "$SCRIPT_TTL" -eq 0 ]]; then
+ ((SCRIPT_TTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
else
yell "ERROR: timeUntilNextHour exit code $?"; exit 1;
fi;
fi;
else
- yell "ERROR:Invalid argument for setScriptTTL function."; exit 1;
+ yell "ERROR:Invalid argument for setScriptTTL function:$argTimeElement"; exit 1;
fi
} # Seconds until next (day|hour).
checkMakeTar() {
try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
#yell "DEBUG:STATUS:$FN:Finished appendFileTar()."
} # Append file to Tar archive
+checkAgePubkey() {
+ # Desc: Checks if string is an age-compatible pubkey
+ # Usage: checkAgePubkey [str pubkey]
+ # Version: 0.1.2
+ # Input: arg1: string
+ # Output: return code 0: string is age-compatible pubkey
+ # return code 1: string is NOT an age-compatible pubkey
+ # age stderr (ex: there is stderr if invalid string provided)
+ # Depends: age (v0.1.0-beta2; https://github.com/FiloSottile/age/releases/tag/v1.0.0-beta2 )
+
+ argPubkey="$1";
+
+ if echo "test" | age -a -r "$argPubkey" 1>/dev/null; then
+ return 0;
+ else
+ return 1;
+ fi;
+} # Check age pubkey
validateInput() {
# Desc: Validates Input
# Usage: validateInput [str input] [str input type]
- # Version: 0.2.1
+ # Version: 0.3.0
# Input: arg1: string to validate
# arg2: string specifying input type (ex:"ssh_pubkey")
# Output: return code 0: if input string matched specified string type
### Check for alnum/dash base64 (ex: "ssh-rsa AAAAB3NzaC1yc2EAAA")
if [[ "$argType" = "ssh_pubkey" ]]; then
if [[ "$argInput" =~ ^[[:alnum:]-]*[\ ]*[[:alnum:]+/=]*$ ]]; then
- return 0; fi; fi;
+ return 0; fi; fi;
## age_pubkey
### Check for age1[:bech32:]
if [[ "$argInput" =~ ^age1[qpzry9x8gf2tvdw0s3jn54khce6mua7l]*$ ]]; then
return 0; fi; fi
+ ## integer
+ if [[ "$argType" = "integer" ]]; then
+ if [[ "$argInput" =~ ^[[:digit:]]*$ ]]; then
+ return 0; fi; fi;
+
+ ## time element (year, month, week, day, hour, minute, second)
+ if [[ "$argType" = "time_element" ]]; then
+ if [[ "$argInput" = "year" ]] || \
+ [[ "$argInput" = "month" ]] || \
+ [[ "$argInput" = "week" ]] || \
+ [[ "$argInput" = "day" ]] || \
+ [[ "$argInput" = "hour" ]] || \
+ [[ "$argInput" = "minute" ]] || \
+ [[ "$argInput" = "second" ]]; then
+ return 0; fi; fi;
+
# Return error if no condition matched.
return 1;
} # Validates strings
+timeEpochNS() {
+ # Desc: Get epoch nanoseconds
+ # Usage: timeEpochNS
+ # Version 0.2.2
+ # Input: arg1: 'date'-parsable timestamp string (optional)
+ # Output: Nanoseconds since 1970-01-01
+ # Depends: date 8, yell()
+ # Ref/Attrib: Force base 10 Bash arith with '10#'. https://stackoverflow.com/a/24777667
+ local TIME_CURRENT TIME_INPUT TIME_EPOCH_FLOAT TIME_EPOCH_NSFRAC
+ local TIME_EPOCH_NS
+
+ argTime="$1";
+
+ # Get Current Time
+ TIME_CURRENT="$(date --iso-8601=ns)"; # Produce `date`-parsable current timestamp with resolution of 1 nanosecond.
+
+ # Decide to parse current or supplied time
+ ## Check if time argument empty
+ if [[ -z "$argTime" ]]; then
+ ## T: Time argument empty, use current time
+ TIME_INPUT="$TIME_CURRENT";
+ else
+ ## F: Time argument exists, validate time
+ if date --date="$argTime" 1>/dev/null 2>&1; then
+ ### T: Time argument is valid; use it
+ TIME_INPUT="$argTime";
+ else
+ ### F: Time argument not valid; exit
+ yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+ fi;
+ fi;
+ # Construct and deliver nanoseconds since 1970-01-01
+ TIME_EPOCH_FLOAT="$(date --date="$TIME_INPUT" +%s.%N)"; # Save ssss.NNNNNNNNN
+ TIME_EPOCH_INT="$(echo "$TIME_EPOCH_FLOAT" | cut -d. -f1)"; # Get ssss
+ TIME_EPOCH_NSFRAC="$(echo "$TIME_EPOCH_FLOAT" | cut -d. -f2)"; # Get NNNNNNNNN
+ TIME_EPOCH_NS="$(( (10#"$TIME_EPOCH_INT" * 10**9) + (10#"$TIME_EPOCH_NSFRAC") ))";
+ echo "$TIME_EPOCH_NS";
+} # Nanoseconds since 1970-01-01
+magicBufferSleepPID() {
+ # Desc: Compensates for lag so buffer rounds start every BUFFER_TTL seconds
+ # Input: vars: BUFFER_TTL, errResetx10e3, K_P, T_I, T_D
+ # # Input: array: errorHistory
+ # Output: vars: BUFFER_TTL_ADJ_FLOAT
+ # Re/Attrib: https://en.wikipedia.org/wiki/PID_controller#Standard_versus_parallel_(ideal)_form
+ local BUFFER_TTL_NS
+ local timeBufferStartNS timeBufferStartNSExp errNS errNSx10e3
+ local errResetx10e3 errRatex10e3 ADJ BUFFER_TTL_ADJ_NS BUFFER_TTL_ADJ_INT
+ local BUFFER_TTL_ADJ_FLOATFRAC
+ # local errorHistorySize
+
+ # ## Define errorHistorySize
+ # errorHistorySize=100;
+ ## Define BUFFER_TTL in nanoseconds
+ BUFFER_TTL_NS=$((BUFFER_TTL * 10**9)) && vbm "BUFFER_TTL_NS:$BUFFER_TTL_NS";
+
+ ### PID Control factors
+ K_P=1; # Gain for compensating buffer round lag
+ T_I="$(((4)*BUFFER_TTL_NS/(1)))"; # Consider this number of past nanoseconds to eliminate error
+ T_D="$(((1)*BUFFER_TTL_NS/(1)))"; # Predict value this number of nanoseconds into the future
+
+ # Calculate Error, errNS, in nanoseconds
+ ## Get current time
+ timeBufferStartNS="$(timeEpochNS)" && vbm "timeBufferStartNS :$timeBufferStartNS";
+ ## Calculate expected time (from start time, current buffer round number, nominal BUFFER_TTL)
+ timeBufferStartNSExp="$(( (timeBufferFirstNS) + (BUFFER_TTL_NS * bufferRound) ))" && vbm "timeBufferStartNSExp:$timeBufferStartNSExp";
+ ## Calculate error (diff between timeBufferStartNSExp and timeBufferStartNS; usually negative)
+ errNS="$(( timeBufferStartNSExp - timeBufferStartNS ))" && vbm "errNS:$errNS";
+# errNSx10e3="$((errNS*10**3))" && vbm "errNSx10e3:$errNSx10e3";
+ # ## Append error to errorHistory
+ # errorHistory+=("errNS");
+ # ### Trim errorHistory array if over errorHistorySize
+ # while [[ "${#errorHistory[@]}" -gt "errorHistorySize" ]]; then do
+ # unset "errorHistory[0]"; # remove oldest entry, creating sparse array
+ # errorHistory=("${errorHistory[@]}"); # reindex sparse array
+ # vbm "STATUS:Trimmed errorHistory array. Entry count:${#errorHistory[@]}";
+ # done;
+
+ # Calculate errReset in nanoseconds^2
+ ## errReset = int(errHistory(t),wrt(delta_BUFFER_TTL))
+ ## Integrate errorHistory with respect to time
+ # for value in "${errorHistory[@]}"; do
+ # errReset=$(( errReset + ( value*BUFFER_TTL_NS ) ));
+ # done;
+ vbm "errReset(orig):$errReset"
+ errReset="$(( (errReset + (errNS*BUFFER_TTL_NS)) ))" && vbm "errReset(post):$errReset";
+# errResetx10e3="$(( ( errResetx10e3 + ( errNSx10e3 * BUFFER_TTL_NS ) )*10**3 ))" && vbm "errResetx10e3:$errResetx10e3";
+
+ # Calculate errRate in nanoseconds per nanosecond
+ errRate="$(( errNS / BUFFER_TTL_NS ))" && vbm "errRate:$errRate";
+# errRatex10e3="$(( ( errNSx10e3 ) / BUFFER_TTL_NS ))" && vbm "errRatex10e3:$errRatex10e3";
+
+ # Debug
+ vbm "errNS :$errNS";
+ vbm "errResetTerm:$((errReset/T_I))";
+ vbm "errRateTerm :$((errRate*T_D))";
+
+ # Calculate PID control signal
+ ## ADJ = K_P * (errNS + errReset/T_I + errRate*T_D)
+ ADJ="$(( K_P*(errNS + errReset/T_I + errRate*T_D) ))" && vbm "ADJ:$ADJ";
+# ADJ="$((K_P*(errNSx10e3 + (errResetx10e3/T_I) + (errRatex10e3*T_D) )/(10**3)))" && vbm "ADJ:$ADJ";
+
+ # Calculate BUFFER_TTL_ADJ_FLOAT from ADJ (ns)
+ ## Calculate BUFFER_TTL_ADJ in nanoseconds (BUFFER_TTL_ADJ_NS = BUFFER_TTL_NS + ADJ)
+ BUFFER_TTL_ADJ_NS="$((BUFFER_TTL_NS + ADJ))" && vbm "BUFFER_TTL_ADJ_NS:$BUFFER_TTL_ADJ_NS";
+ ## Calculate integer seconds
+ BUFFER_TTL_ADJ_INT="$((BUFFER_TTL_ADJ_NS/(10**9)))" && vbm "BUFFER_TTL_ADJ_INT:$BUFFER_TTL_ADJ_INT";
+ ### Catch negative integer seconds, set minimum of BUFFER_TTL/10 seconds
+ if [[ "$BUFFER_TTL_ADJ_INT" -le "$((BUFFER_TTL/10))" ]]; then
+ BUFFER_TTL_ADJ_INT="$((BUFFER_TTL/10))";
+ yell "WARNING:Buffer lag adjustment yielded negative seconds.";
+ fi;
+ ## Calculate nanosecond remainder
+ ### Remove integer
+ BUFFER_TTL_ADJ_FLOATFRAC="$((BUFFER_TTL_ADJ_NS - (BUFFER_TTL_ADJ_INT*(10**9)) ))" && vbm "BUFFER_TTL_ADJ_FLOATFRAC:$BUFFER_TTL_ADJ_FLOATFRAC";
+ ### Calc absolute value of fraction (by removing '-' if present; see https://stackoverflow.com/a/47240327
+ BUFFER_TTL_ADJ_FLOATFRAC="${BUFFER_TTL_ADJ_FLOATFRAC#-}" && vbm "BUFFER_TTL_ADJ_FLOATFRAC:$BUFFER_TTL_ADJ_FLOATFRAC";
+ ## Form float BUFFER_TTL_ADJ_FLOAT
+ BUFFER_TTL_ADJ_FLOAT="$BUFFER_TTL_ADJ_INT"."$BUFFER_TTL_ADJ_FLOATFRAC" && vbm "BUFFER_TTL_ADJ_FLOAT:$BUFFER_TTL_ADJ_FLOAT";
+ vbm "STATUS:Calculated adjusted BUFFER_TTL (seconds):$BUFFER_TTL_ADJ_FLOAT";
+} # Calc BUFFER_TTL_ADJ_FLOAT so buffer starts every BUFFER_TTL seconds
magicWriteVersion() {
# Desc: Appends time-stamped VERSION to PATHOUT_TAR
# Usage: magicWriteVersion
} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
magicGatherWriteBuffer() {
# Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
- # Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
- # Inputs: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
- # Depends: yell, try, vbm, appendArgTar, tar
- local FN="${FUNCNAME[0]}";
- wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+ # Inputs: vars: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
+ # Inputs: vars: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
+ # Output: file: (PATHOUT_TAR)
+ # Depends: yell(), try(), vbm(), appendArgTar(), tar 1, sleep 8, checkMakeTar()
+ # Depends: magicWriteVersion(), appendFileTar()
+ local FN
+
+ # Debug:Get function name
+ FN="${FUNCNAME[0]}";
+
# Create buffer file with unique name
PATHOUT_BUFFER="$DIR_TMP/buffer$SECONDS";
# Fill buffer
if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
# Write bufferBash to PATHOUT_TAR
+ wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
rm "$PATHOUT_BUFFER" "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
vbm "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
} # write buffer to disk
-
-main() {
- processArguments "$@" # Process arguments.
-
- # Determine working directory
- ## Set DIR_TMP_PARENT to user-specified value if specified
- if [[ "$OPTION_TMPDIR" = "true" ]]; then
- if [[ -d "$TMP_DIR_PRIORITY" ]]; then
- DIR_TMP_PARENT="$OPTION_TMPDIR";
+magicParseRecipientDir() {
+ # Desc: Updates recPubKeysValid with pubkeys in dir specified by '-R' option ("recipient directory")
+ # Inputs: vars: OPTION_RECDIR, argRecDir, OPTION_ENCRYPT
+ # arry: recPubKeysValid
+ # Outputs: arry: recPubKeysValid
+ # Depends: processArguments,
+ local recFileLine updateRecipients recipientDir
+ declare -a candRecPubKeysValid
+
+ # Check that '-e' and '-R' set
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ ### Check that argRecDir is a directory.
+ if [[ -d "$argRecDir" ]]; then
+ recipientDir="$argRecDir" && vbm "STATUS:Recipient watch directory detected:\"$recipientDir\"";
+ #### Initialize variable indicating outcome of pubkey review
+ unset updateRecipients
+ #### Add existing recipients
+ candRecPubKeysValid=("${recPubKeysValidStatic[@]}");
+ #### Parse files in recipientDir
+ for file in "$recipientDir"/*; do
+ ##### Read first line of each file
+ recFileLine="$(head -n1 "$file")" && vbm "STATUS:Checking if pubkey:\"$recFileLine\"";
+ ##### check if first line is a valid pubkey
+ if checkAgePubkey "$recFileLine" && \
+ ( validateInput "$recFileLine" "ssh_pubkey" || validateInput "$recFileLine" "age_pubkey"); then
+ ###### T: add candidate pubkey to candRecPubKeysValid
+ candRecPubKeysValid+=("$recFileLine") && vbm "STATUS:RecDir pubkey is valid pubkey:\"$recFileLine\"";
+ else
+ ###### F: throw warning;
+ yell "ERROR:Invalid recipient file detected. Not modifying recipient list."
+ updateRecipients="false";
+ fi;
+ done
+ #### Write updated recPubKeysValid array to recPubKeysValid if no failure detected
+ if ! [[ "$updateRecipients" = "false" ]]; then
+ recPubKeysValid=("${candRecPubKeysValid[@]}") && vbm "STATUS:Wrote candRecPubkeysValid to recPubKeysValid:\"${recPubKeysValid[*]}\"";
+ fi;
else
- yell "WARNING:Specified temporary working directory not valid:$OPTION_TMPDIR";
- exit 1;
- fi
- fi
-
- ## Set DIR_TMP_PARENT to default or fallback otherwise
- if [[ -d "$DIR_TMP_DEFAULT" ]]; then
- DIR_TMP_PARENT="$DIR_TMP_DEFAULT";
- elif [[ -d /tmp ]]; then
- yell "WARNING:/dev/shm not available. Falling back to /tmp .";
- DIR_TMP_PARENT="/tmp";
- else
- yell "ERROR:No valid working directory available. Exiting.";
- exit 1;
- fi
-
- ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
- DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
-
- # Set output encryption and compression option strings
- if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
+ yell "ERROR:$0:Recipient directory $argRecDir does not exist. Exiting."; exit 1;
+ fi;
+ fi;
+ # Handle case if '-R' set but '-e' not set
+ if [[ ! "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ yell "ERROR: \\'-R\\' is set but \\'-e\\' is not set."; fi;
+} # Update recPubKeysValid with argRecDir
+magicParseRecipientArgs() {
+ # Desc: Parses recipient arguments specified by '-r' option
+ # Input: vars: OPTION_ENCRYPT from processArguments()
+ # arry: argRecPubKeys from processArguments()
+ # Output: vars: CMD_ENCRYPT, CMD_ENCRYPT_SUFFIX
+ # arry: recPubKeysValid, recPubKeysValidStatic
+ # Depends: checkapp(), checkAgePubkey(), validateInput(), processArguments()
+ local recipients
+
+ # Check if encryption option active.
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECIPIENTS" = "true" ]]; then
if checkapp age; then # Check that age is available.
- for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+ for pubkey in "${argRecPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
vbm "DEBUG:Testing pubkey string:$pubkey";
- if echo "butts" | age -a -r "$pubkey" 1>/dev/null &&
+ if checkAgePubkey "$pubkey" && \
( validateInput "$pubkey" "ssh_pubkey" || validateInput "$pubkey" "age_pubkey"); then
#### Form age recipient string
recipients="$recipients""-r '$pubkey' ";
recPubKeysValid+=("$pubkey") && vbm "DEBUG:recPubkeysValid:pubkey added:$pubkey";
else
yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
- fi
+ fi;
done
- vbm "DEBUG:Finished processing recPubKeys array";
+ vbm "DEBUG:Finished processing argRecPubKeys array";
+ vbm "STATUS:Array of validated pubkeys:${recPubKeysValid[*]}";
+ recPubKeysValidStatic=("${recPubKeysValid[@]}"); # Save static image of pubkeys validated by this function
## Form age command string
CMD_ENCRYPT="age ""$recipients " && vbm "CMD_ENCRYPT:$CMD_ENCRYPT";
CMD_ENCRYPT_SUFFIX=".age" && vbm "CMD_ENCRYPT_SUFFIX:$CMD_ENCRYPT_SUFFIX";
else
yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
- fi
+ fi;
else
CMD_ENCRYPT="tee /dev/null " && vbm "CMD_ENCRYPT:$CMD_ENCRYPT";
CMD_ENCRYPT_SUFFIX="" && vbm "CMD_ENCRYPT_SUFFIX:$CMD_ENCRYPT_SUFFIX";
vbm "DEBUG:Encryption not enabled."
- fi
+ fi;
+ # Catch case if '-e' is set but '-r' or '-R' is not
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ ! "$OPTION_RECIPIENTS" = "true" ]]; then
+ yell "ERROR:\\'-e\\' set but no \\'-r\\' or \\'-R\\' set."; exit 1; fi;
+ # Catch case if '-r' or '-R' set but '-e' is not
+ if [[ ! "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECIPIENTS" = "true" ]]; then
+ yell "ERROR:\\'-r\\' or \\'-R\\' set but \\'-e\\' is not set."; exit 1; fi;
+} # Populate recPubKeysValid with argRecPubKeys; form encryption cmd string and filename suffix
+magicParseCompressionArg() {
+ # Desc: Parses compression arguments specified by '-c' option
+ # Input: vars: OPTION_COMPRESS
+ # Output: CMD_COMPRESS, CMD_COMPRESS_SUFFIX
+ # Depends: checkapp(), vbm(), gzip,
if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
if checkapp gzip; then # Check if gzip available
CMD_COMPRESS="gzip " && vbm "CMD_COMPRESS:$CMD_COMPRESS";
CMD_COMPRESS="tee /dev/null " && vbm "CMD_COMPRESS:$CMD_COMPRESS";
CMD_COMPRESS_SUFFIX="" && vbm "CMD_COMPRESS_SUFFIX:$CMD_COMPRESS_SUFFIX";
vbm "DEBUG:Compression not enabled.";
- fi
+ fi
+} # Form compression cmd string and filename suffix
+magicInitWorkingDir() {
+ # Desc: Determine temporary working directory from defaults or user input
+ # Usage: magicInitWorkignDir
+ # Input: vars: OPTION_TEMPDIR, argTempDirPriority, DIR_TMP_DEFAULT
+ # Input: vars: SCRIPT_TIME_START
+ # Output: vars: DIR_TMP
+ # Depends: processArguments(), vbm(), yell()
+ # Parse '-t' option (user-specified temporary working dir)
+ ## Set DIR_TMP_PARENT to user-specified value if specified
+ local DIR_TMP_PARENT
+
+ if [[ "$OPTION_TMPDIR" = "true" ]]; then
+ if [[ -d "$argTempDirPriority" ]]; then
+ DIR_TMP_PARENT="$argTempDirPriority";
+ else
+ yell "WARNING:Specified temporary working directory not valid:$argTempDirPriority";
+ exit 1; # Exit since user requires a specific temp dir and it is not available.
+ fi;
+ else
+ ## Set DIR_TMP_PARENT to default or fallback otherwise
+ if [[ -d "$DIR_TMP_DEFAULT" ]]; then
+ DIR_TMP_PARENT="$DIR_TMP_DEFAULT";
+ elif [[ -d /tmp ]]; then
+ yell "WARNING:$DIR_TMP_DEFAULT not available. Falling back to /tmp .";
+ DIR_TMP_PARENT="/tmp";
+ else
+ yell "ERROR:No valid working directory available. Exiting.";
+ exit 1;
+ fi
+ fi;
+ ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
+ DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
+} # Sets working dir
+magicParseCustomTTL() {
+ # Desc: Set user-specified TTLs for buffer and script
+ # Input: vars: argCustomBufferTTL (integer), argCustomScriptTTL_TE (string)
+ # Input: vars: OPTION_CUSTOM_BUFFERTTL, OPTION_CUSTOM_SCRIPTTTL
+ # Input: vars: BUFFER_TTL (integer), SCRIPT_TTL_TE (string)
+ # Output: BUFFER_TTL (integer), SCRIPT_TTL_TE (string)
+ # Depends validateInput(), showUsage(), yell
+
+ # React to '-b, --buffer-ttl' option
+ if [[ "$OPTION_CUSTOM_BUFFERTTL" = "true" ]]; then
+ ## T: Check if argCustomBufferTTL is an integer
+ if validateInput "$argCustomBufferTTL" "integer"; then
+ ### T: argCustomBufferTTL is an integer
+ BUFFER_TTL="$argCustomBufferTTL";
+ else
+ ### F: argcustomBufferTTL is not an integer
+ yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
+ fi;
+ ## F: do not change BUFFER_TTL
+ fi;
+
+ # React to '-B, --script-ttl' option
+ if [[ "$OPTION_CUSTOM_SCRIPTTTL_TE" = "true" ]]; then
+ ## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
+ if validateInput "$argCustomScriptTTL" "time_element"; then
+ ### T: argCustomScriptTTL is a time element
+ SCRIPT_TTL_TE="$argCustomScriptTTL";
+ else
+ ### F: argcustomScriptTTL is not a time element
+ yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
+ fi;
+ ## F: do not change SCRIPT_TTL_TE
+ fi;
+} # Sets custom script or buffer TTL if specified
+
- # Check that critical apps and dirs are available, displag missing ones.
- if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "/dev/shm"; then
+main() {
+ # Process arguments
+ processArguments "$@";
+ ## Act upon arguments
+ ### Determine working directory
+ magicInitWorkingDir; # Sets DIR_TMP from argTempDirPriority
+ ### Set output encryption and compression option strings
+ #### React to "-r" ("encryption recipients") option
+ magicParseRecipientArgs; # Updates recPubKeysValid, CMD_ENCRYPT[_SUFFIX] from argRecPubKeys
+ #### React to "-c" ("compression") option
+ magicParseCompressionArg; # Updates CMD_COMPRESS[_SUFFIX]
+ #### React to "-R" ("recipient directory") option
+ magicParseRecipientDir; # Updates recPubKeysValid
+ #### React to custom buffer and script TTL options ("-b", "-B")
+ magicParseCustomTTL; # Sets custom SCRIPT_TTL_TE and/or BUFFER_TTL if specified
+
+ # Check that critical apps and dirs are available, display missing ones.
+ if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "DIR_TMP"; then
yell "ERROR:Critical components missing.";
displayMissing; yell "Exiting."; exit 1; fi
- # Set script lifespan
- setScriptTTL "$SCRIPT_TTL"; # seconds until next new SCRIPT_TTL (ex: "day" or "hour")
+ # Set script lifespan (SCRIPT_TTL from SCRIPT_TTL_TE)
+ magicSetScriptTTL "$SCRIPT_TTL_TE";
+ ## Note: SCRIPT_TTL_TE is time element string (ex: "day") while SCRIPT_TTL is integer seconds
- # File name substring: encoded bufferTTL
- bufferTTL_STR="$(timeDuration $BUFFER_TTL)";
+ # File name substring (ISO-8601 duration from BUFFER_TTL)
+ bufferTTL_STR="$(timeDuration "$BUFFER_TTL")";
# Init temp working dir
try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
# MAIN LOOP:Record gps data until script lifespan ends
- while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
+ timeBufferFirstNS="$(timeEpochNS)"; bufferRound=0; BUFFER_TTL_ADJ_FLOAT="10.0";
+ while [[ "$SECONDS" -lt "$SCRIPT_TTL" ]]; do
+ magicParseRecipientDir;
magicGatherWriteBuffer &
- sleep "$BUFFER_TTL";
+ sleep "$BUFFER_TTL_ADJ_FLOAT";
+ ((bufferRound++));
+ magicBufferSleepPID; # Calculates BUFFER_TTL_ADJ from BUFFER_TTL given buffer expected start time vs. actual
done
# Cleanup
152K relerror-1000.kml
#+END_EXAMPLE
+** TODO Feature: Generalize bkgpslog to bklog function
+2020-07-05T02:42Z; bktei> Transform ~bkgpslog~ into a modular
+component called ~bklog~ such that it processes a stdout stream of any
+external command, not just ~gpspipe -r~. This would permit reuse of
+the ~bkgpslog~ code for logging not just GPS data but things like
+pressure, temperature, system statistics, etc.
+2020-07-05T16:35Z; bktei>
+: bklog -r age1asdf -o log.tar # encrypt/compress stdin to log.tar
+: bklog -x -f log.tar -i age.key -O /tmp # extract and decrypt
+
+Making ~bklog~ follow the [[https://en.wikipedia.org/wiki/Unix_philosophy][Unix philosophy]] means that it shouldn't care
+what kind of text is fed to it.
+
+*** ~bklog~ Design vs. Unix Philosophy
+**** Pubkey dir watching
+The feature of periodically checking a directory for changes in the
+pubkeys it contains should be justified by its usefulness; if the
+complexity cannot be justified then the feature should be removed.
+**** Defaults vs options
+Many options can cause the tool to become complex in unjustifiable
+ways. Currently I am adding options because I want the ability to
+modify the script's behavior without having to modify the source code
+on the machine in which the code is running. I should consider
+removing features at some point and having the program force defaults
+on the user. For example, allowing the specification of a temporary
+directory, while useful for me, is probably not useful for most people
+who don't know or care about the difference between ~/tmp~ and
+~/dev/shm~.
+**** Script time to live (TTL)
+I initially implemented a script time-to-live feature because I was
+unsure in my ability to program script that could run for long periods
+of time without causing a runaway usage of memory. I still think it's
+a good idea to offer a script TTL option to the user but I think the
+default should be to simply run forver.
+** TODO: Evaluate ~rsyslog~ as stand-in for this work
+2020-07-05T02:57Z; bktei> I searched for "debian iot logging" ("iot"
+as in "Internet of Things", the current buzzword for small low-power
+computers being used to provide microservices for owners in their own
+home) and came across several search results mentioning ~syslog~ and
+~rsyslog~.
+
+https://www.thissmarthouse.net/consolidating-iot-logs-into-mysql-using-rsyslog/
+https://rsyslog.readthedocs.io/en/latest/tutorials/tls.html
+https://serverfault.com/questions/20840/how-would-you-send-syslog-securely-over-the-public-internet
+https://www.rsyslog.com/
+
+My impression is that ~rsyslog~ is a complex software package designed
+to offer many features, some of which possibly might satisfy my
+needs.
+
+However, as stated in the repository README, the objective of the
+~ninfacyzga-01~ project is "Observing facts of the new". This means
+that the goal is not only to record location data but any data that
+can be captured by a sensor. This means the capture of the following
+environmental phenomena are within the scope of this device:
+
+*** Sounds (microphone)
+*** Light (camera)
+*** Temperature (thermocouple)
+*** Air Pressure (barometer)
+*** Acceleration Vector (acceleromter / gyroscope)
+*** Magnetic Field Vector (magnetometer)
+
+This brings up the issue of respecting privacy of others in shared
+spaces through which ~ninfacyzga-01~ may pass through. ~ninfacyzga-01~
+should encrypt data it records according to rules set by its
+owner.
+
+One permissive rule could be that if ~ninfacyzga-01~ detects that a
+person (let's call her Alice) enters a room, it should add Alice's
+encryption public key to the list of recipients against which it
+encrypts data without Alice having to know how ~ninfacyzga-01~ is
+programmed (she might have a ~calkuptcana~ agent on her person that
+broadcasts her privacy preferences). Meanwhile, ~ninfacyzga-01~ may
+publish its observations to a repository that Alice and other members
+of the shared communal space have access to (ex: a read-only shared
+directory on a local network WiFi). Alice could download all the files
+in the shared repository but she would only be able to decrypt files
+generated when she was physically near enough to ~ninfacyzga-01~ for
+it to detect that her presence was within some spatial boundary.
+
+A more restrictive rule could resemble the permissive rule in that
+~ninfacyzga-01~ uses Alice's encryption public key only when she is
+physically near by, except that it encrypts logged files against
+public keys in a sequential manner. This would mean that all people
+who were near ~ninfacyzga-01~ would have to pass around each log file
+to eachother so that they could decrypt the content.
+
+That said, according to [[https://www.rsyslog.com/doc/master/tutorials/database.html][this ~rsyslog~ page]], ~rsyslog~ is more a data
+wrangling system for collecting data from disparate sources of
+different types and outputting data to text files on disk than a
+system committed to the server-client model of database storage. So, I
+think converting ~bkgpslog~ into a ~bklog~ script that appends
+encrypted and compressed data to a tar file for later extraction
+(possibly the same script with future features) would be best.
+
+** TODO: Place persistent recip. updates in asynchronous coproc
+2020-07-06T19:37Z; bktei> In order to update the recipient list, the
+magicParseRecipientDir() function needs to be run each buffer period
+in order to scan for changes in the recipient list. However, such a
+scan takes time; if the magicGatherWriteBuffer() function must pause
+until magicParseRecipientDir() completes, then a significant pause
+between buffer sessions may occur, causing detectable gaps in location
+data between buffer rounds.
+
+I looked for ways in which I might start magicParseRecipientDir()
+asynchronously immediately before running the data collection command
+and then collect its output at the start of the next buffer round. One
+way using the ~coproc~ Bash built-in is described [[https://stackoverflow.com/a/20018504/10850071][here]]. I'd have to
+make the asynchronous function output the recipient list to stdout
+which would then be ~read~ into the ~recPubKeysValid~ array in the
+main loop. However, for now, I'm putting the magicParseRecipientDir()
+as-is in the main loop and accepting the delay for now.
* bkgpslog narrative
** Initialize environment
*** Init variables